<%@page import="dermi.*, org.planet.snap.*, org.snap.jounin.*, org.planet.p2pcm.*, java.util.*, java.io.*" %>
<%@include file="extra/components.jsp" %>
<%	
	String username = (String)session.getAttribute("participant");
	if(username==null) response.sendRedirect("index.jsp");

	String portal_id = (String)session.getAttribute("portal");
	if(portal_id==null) response.sendRedirect("jounin.jsp");
	
	Participant part = jounin.getParticipant(username);
	Portal portal = jounin.getPortal(portal_id);

	//Check if the user is really an admin
	if(portal.getParticipantRol(part.getName()) != Portal.Rol.ADMIN) {
		response.sendRedirect("jounin.jsp?error=notadmin");
	}

	Application jounin_app = (Application) application.getAttribute ("snapApp");

	String name = request.getParameter("name");
	String url = request.getParameter("p2purl");
	String server = (String) application.getAttribute ("serverName");
	if(name==null || url==null || server==null){
		response.sendRedirect("admin_portal.jsp");
	}

	String snapTimer = "" + System.currentTimeMillis();
	url = "p2p://snap.deim.urv.net" + url.substring (5, url.length());
	IApplication toLoadSnapAppStub = Application.loadMainSNAPApp (application.getRealPath (File.separator), url);
	
	Properties snapAppProps = null;	
	// Gotta lookup the specified p2purl searching for a decentralized web application
	try {
		snapAppProps = jounin_app.redirectToSnapApp (url, "." + File.separator + "webapps", toLoadSnapAppStub);
	} catch (dermi.exception.NotBoundException e) {
		response.sendRedirect("admin_portal.jsp?error=appnotfound");
	}

	if (snapAppProps !=null && snapAppProps.getProperty ("LOCAL").equalsIgnoreCase ("true")) {
		// Check whether to wait for local deployment to be complete
		if (snapAppProps.getProperty ("TIMEOUT").equalsIgnoreCase ("true")) {
			Thread.currentThread().sleep (5000);
   		}
		portal.addPortlet(name, "http://" + server + ":" + request.getServerPort() + "/" + snapAppProps.getProperty ("URL") + "/");
   	} else {
		portal.addPortlet(name, response.encodeRedirectURL (snapAppProps.getProperty ("URL")) + "/");
	}

	ParticipantProfile pp = part.getPortletProfile(name, portal_id);
	pp.setType(ParticipantProfile.PortletType.P2P);

	response.sendRedirect("admin_portal.jsp");
%>
