<%@page import="dermi.*, org.planet.snap.*, org.snap.jounin.*, org.planet.p2pcm.*, java.util.*" %>
<%
	response.setHeader("Cache-Control","no-cache"); //HTTP 1.1
	response.setHeader("Pragma","no-cache"); //HTTP 1.0
	response.setDateHeader ("Expires", 0); //prevents caching at the proxy serve
%>
<%@include file="extra/components.jsp" %>
<%
	String username = (String)session.getAttribute("participant");
	if(username==null) response.sendRedirect("index.jsp");

	String portal_id = (String)session.getAttribute("portal");
	if(portal_id==null) response.sendRedirect("jounin.jsp");
	
	Participant participant = jounin.getParticipant(username);
	Portal portal = jounin.getPortal(portal_id);

	//Check if the user is really an admin
	if(portal.getParticipantRol(participant.getName()) != Portal.Rol.ADMIN) {
		response.sendRedirect("jounin.jsp?error=notadmin");
	}

	String error = request.getParameter("error");
%>

<%@include file="extra/main_header.jsp" %>

<div class="box">
	Return to <a href="portal.jsp">portal</a>.
</div>

<table width="100%" cellspacing="0" cellpadding="0">
<tr><td valign="top">

	<div class="box">
		<h1>Available portlets:</h1>
		<%  Collection portlets = portal.getPortlets();
			Iterator it = portlets.iterator();
			boolean sw = true;
			for (int i=0;it.hasNext();i++) {
				String idString = (String) it.next();
				String color = "#a1d9ff";
				if (sw) color = "#6e8dd3";
				sw = !sw;
				%><div style="padding: 4px; margin: 0px; padding-left:20px; height: 18px; background-color: <%=color%>">
				<span style="float: left; display:inline"><%=idString%></span>
				<a href="del_portlet.jsp?name=<%=idString%>" style="float:right; display:inline;" onclick="return Confirm('Are you sure ?');">
				<img src="images/trash.gif" border="0"/></a>
				</div><%
			}
		%>
	</div>

	<div class="box">
		<h1>Add new portlet</h1>
		<form action="add_portlet.jsp" method="post" onsubmit="return ValidateForm(document.forms[0]);">
			<table align="center">
				<tr><td>Name:</td><td><input type="text" name="name" size="50"/></td></tr>
				<tr><td>p2pURL:</td><td><input type="text" value="p2p://" name="p2purl" size="50"/></td></tr>
			</table>
			<input type="submit" value="Add" />
		</form>
	</div>
	
	<div class="box">
		<h1>Add web portlet</h1>
		<form action="add_web.jsp" method="post" onsubmit="return ValidateForm(document.forms[1]);">
			<table align="center">
				<tr><td>Name:</td><td><input type="text" name="name" size="50"/></td></tr>
				<tr><td>webURL:</td><td><input type="text" value="http://" name="weburl" size="50"/></td></tr>
			</table>
			<input type="submit" value="Add" />
		</form>
	</div>
	
</td><td valign="top">

	<div class="box">
		<h1>Participants</h1>
		<table align="center">
		<th>Username</th><th>Rol</th><th>Save</th><th>Delete</th>
		<%
		Collection participants = portal.getParticipants();
		it = participants.iterator();
		for (int i=0; it.hasNext(); i++) {
			String idString = (String) it.next();
		%>
			<form action="change_rol.jsp" method="post">
			<tr><td><b><%=idString%></b></td>
			<td><select name="rol">
			<%	Portal.Rol rol = portal.getParticipantRol(idString); %>
				<option value="admin" <%=(rol==Portal.Rol.ADMIN)?"selected":""%>>Administrator</option>
				<option value="user" <%=(rol==Portal.Rol.USER)?"selected":""%>>User</option>
			</select></td>
			<td><input type="submit" name="change" value="Change" <%=(participant.getName().compareTo(idString)==0)?"disabled":""%>/></td>
			<td><input type="submit" name="delete" value="Delete" onclick="return Confirm('Are you sure ?');" <%=(participant.getName().compareTo(idString)==0)?"disabled":""%>/></td></tr>
			<input type="hidden" name="user" value="<%=idString%>"/>
			</form>
		<%
		}
		%>
		</table>
	</div>

	<div class="box">
		<h1>Invite a new participant</h1>
		<form action="invite_participant.jsp" method="post">
		Username: <input type="text" name="name" size="50"/>
		<input type="submit" value="Invite"/>
		</form>
	</div>

</tr></td>
</table>

<script>
<%
	if(error!=null) {
		if(error.compareTo("usernotfound")==0) {
			out.println("alert('User not found')");
		}else if(error.compareTo("appnotfound")==0) {
			out.println("alert('P2P application not found')");
		}
	}
%>
</script>

<%@include file="extra/main_footer.jsp" %>
