package org.snap.jounin;

import org.planet.p2pcm.*;
import dermi.core.*;
import dermi.exception.*;
import dermi.annotation.*;

import java.util.*;

@DermiRemoteInterface
public interface Participant extends ComponentInterface {
	@RemoteMethod(granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public String getName() throws RemoteException;

	@RemoteMethod(granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public Id getPassword() throws RemoteException;

	@RemoteMethod(granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public Collection getPortals() throws RemoteException;

	@RemoteMethod(granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public void addPortal(String portal) throws RemoteException;
	
	@RemoteMethod(granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public void delPortal(String portal) throws RemoteException;
	
	@RemoteMethod(granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public ParticipantProfile getPortletProfile(String portlet, String portal) throws RemoteException;
	
	@RemoteMethod(granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public void delete() throws RemoteException;
}